#ifndef __LCD_H
#define __LCD_H

#define Yellow1 0xEFC0
#define Yellow2 0xCEA0
#define Yellow3 0xF785
#define Orange1 0xFB42
#define Orange2 0xFC26
#define Orange3 0xFAE0
#define Red1    0xF800
#define Red2    0xE000
#define Red3    0xB800
#define Green1  0x4DC0
#define Green2  0x1521
#define Green3  0x0B82
#define Gray1   0x6B4D
#define Gray2   0x8C71
#define Gray3   0xAD54
#define Blue1   0x085D
#define Blue2   0x3A1E
#define Blue3   0x16BD
#define Blue5   0x1334
#define Blue4   0x0B34
#define Pink1   0xF9DD
#define Pink2   0xC037
#define Pink3   0x8830
#define Black1  0x0000
#define Black2  0x3186
#define Black3  0x4A69
#define White   0xFFFF
#define agray1  0xCE18
#define agray2  0xBD96
#define ared1   0xFC30


typedef struct
{
	uint16_t  width;			//szerokosc
	uint16_t  height;			//wysokosc
	uint16_t  id;				  //ID wyswietlacz
	uint8_t   dir;			  //kierunek
	uint16_t  wramcmd;		//wpisywanie do ram command
	uint16_t  setxcmd;		//ustaw kasetes x
	uint16_t  setycmd;		//ustaw kasete y
} lcd_dev;

#define USE_HORIZONTAL  	 0
#define LCD_W 320
#define LCD_H 480

//Definicje portow pod ktory podlaczamy wyswietlacz
#define GPIO_TYPE  GPIOA  //Port
#define LED      9        //PA9
#define LCD_CS   11       //PA11
#define LCD_RS   10       //PA10
#define LCD_RST  12       //PA12

#define	LCD_LED_ON    GPIO_TYPE->BSRR=1<<LED
#define LCD_LED_OFF   GPIO_TYPE->BRR=1<<LED


//Definicje portow - sterowanie portami
#define	LCD_CS_SET  GPIO_TYPE->BSRR=1<<LCD_CS
#define	LCD_RS_SET	GPIO_TYPE->BSRR=1<<LCD_RS
#define	LCD_RST_SET	GPIO_TYPE->BSRR=1<<LCD_RST
#define	LCD_CS_CLR  GPIO_TYPE->BRR=1<<LCD_CS
#define	LCD_RS_CLR	GPIO_TYPE->BRR=1<<LCD_RS
#define	LCD_RST_CLR	GPIO_TYPE->BRR=1<<LCD_RST


void delay_ms(uint32_t ms);
void LCD_RESET(void);
void LCD_Init(void);
void LCD_SetWindows(uint16_t xStar, uint16_t yStar,uint16_t xEnd,uint16_t yEnd);
void LCD_SetCursor(uint16_t Xpos, uint16_t Ypos);
void LCD_direction(uint8_t direction);
void Lcd_WriteData_16Bit(uint16_t Data);
void LCD_DrawPoint(uint16_t x,uint16_t y, uint16_t color);
void LCD_WriteRAM_Prepare(void);
void Lcd_WriteData_16Bit(uint16_t Data);
void LCD_WR_REG(uint8_t data);
void LCD_WR_DATA(uint8_t data);
void LCD_Clear(uint16_t Color);
void LCD_WriteReg(uint8_t LCD_Reg, uint16_t LCD_RegValue);
void tft_line(int X1, int Y1,int X2,int Y2,int Color);
void full_rect( int X1, int Y1, int X2, int Y2, uint16_t color);
void putpictures(uint16_t x, uint16_t y, uint16_t width, uint16_t height, unsigned char const *grafika);
void putpicturesscale(uint16_t x, uint16_t y, uint16_t width, uint16_t height, unsigned char const *grafika);
void putscaledwallpaper(unsigned char const *grafika);
void putrectfromwallpaperscaled(uint16_t x1, uint16_t y1, uint16_t x2, uint16_t y2, unsigned char const *grafika, uint8_t alphacolor);
void putpixelfromwallpaper(uint16_t x, uint16_t y, unsigned char const *grafika);
void transparentfromwallpaper(uint16_t x1, uint16_t y1, uint16_t x2, uint16_t y2, unsigned char const *grafika, uint8_t alphared, uint8_t alphagreen, uint8_t alphablue, uint8_t subsum);
uint8_t putmonograph(uint16_t x, uint16_t y, uint16_t color, uint16_t bkcolor, uint16_t width, uint16_t height,const uint8_t *s);
void tft_round_rect(int x, int y, int width, int height, uint8_t radius, uint16_t color1, uint16_t color2);
void tft_round_rect1(int x, int y, int width, int height, uint8_t radius, uint8_t fill, uint16_t color);

#endif

